/*! \file Fwd.h
    \author Wojciech Jarosz
*/
/*
    Copyright (C) 2004-2006 by Wojciech Jarosz, University of California, San Diego.
    wjarosz@ucsd.edu

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the
    Free Software Foundation, Inc.,
    59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
#ifndef MATH_FWD_H
#define MATH_FWD_H

namespace math
{

template <typename T> class Vec2;
typedef Vec2<int>           Vec2i;
typedef Vec2<float>         Vec2f;
typedef Vec2<double>        Vec2d;
typedef Vec2<char>          Vec2c;
typedef Vec2<unsigned char> Vec2uc;

template <typename Vec> class Box;
typedef Box<Vec2i> Box2i;
typedef Box<Vec2f> Box2f;
typedef Box<Vec2d> Box2d;

} // namespace math

#endif // MATH_MATH_FWD_H
