/*! \file Misc.h
    \author Wojciech Jarosz
*/
/*
    Copyright (C) 2004-2006 by Wojciech Jarosz, University of California, San Diego.
    wjarosz@ucsd.edu

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the
    Free Software Foundation, Inc.,
    59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
#ifndef RND_MISC_H
#define RND_MISC_H

namespace rnd
{

inline unsigned
LarcherPillichshammerRIU (unsigned n, unsigned scramble = 0)
{
    for (unsigned v = 1 << 31; n; n >>= 1, v |= v >> 1)
        if (n & 1)
            scramble ^= v;
    
    return scramble;
}

inline float
LarcherPillichshammerRI (unsigned n, unsigned scramble = 0)
{
    return LarcherPillichshammerRIU (n, scramble) / float (0x100000000LL);
}

} // namespace rnd

#endif // RND_MISC_H
